<?php

function printText ($img,$x,$y,$string,$color,$fontsize=10,$font="img/cap_1.ttf") {
	imagettftext($img, $fontsize, 0, $x + $fontsize, $y + $fontsize, $color, $font, $string);
}

function printBio($img, $x, $y, $bio,$color) {
	$bio = "Bio: ".$bio;
	$linewidth=25;
	$lineheight=15;
	$strings = explode("/",wordwrap($bio,$linewidth,"/"));
	for ($i=0; $i < sizeof($strings); $i++)
		printText($img,$x,$y + ($i * $lineheight),$strings[$i],$color);
}

$abilities = array("Adrenal Drip","Adrenal Surge","Air Master","Awareness","Ballistic Weapons","Cautiousness","Denial","Energy Leech","Enhanced Weapons","Ghost","Illegal Light","Illegal Weapons - Dark","Illegal Weapons - Nova","Illegal Weapons - Pike","Illegal Wings", "Iron Legs","Loaded Artifacts", "Loaded Weapons","Mayhem Weapons","Miscellaneous Weapons","Monster Tongue","Power Jump","Quickfoot","Radar","Regeneration","Resupply","Retaliation","Shield Generation","Shields Up","Smart Healing","Speed Switcher","Translocator","Ultima Mini","Ultima","Vampirism");
$en_abilit = array("Adrenal Drip","Adrenal Surge","Air Master","Awareness","Weapons: Ballistic","Cautiousness","Denial","Energy Leech","Weapons: Enhanced","Ghost","Illegal Light","Weapons: Illegal Dark","Weapons: Illegal Nova","Weapons: Illegal Pike","Illegal Wings", "Iron Legs","Artifacts", "Weapons: Loaded","Weapons: Mayhem","Weapons: Miscellaneous","Monster Tongue","Power Jump","Quickfoot","Radar","Regeneration","Resupply","Retaliation","Shield Generation","Shields Up","Smart Healing","Speed Switcher","Translocator","Ultima Mini","Ultima","Vampirism");

$img = imagecreatefrompng("img/cardBg.png");
$border = imagecreatefrompng("img/cardBgBorder.png");

imagealphablending($img,true);
imagealphablending($border,true);

imagesavealpha($img, true);
imagesavealpha($border, true);
$r=0; $g=0; $b=0;

switch($_POST['cardcolor']) {
	case "gray": 	$r=128; $g=128; $b=128; break;
	case "silver": 	$r=191; $g=191; $b=191; break;
	case "maroon": 	$r=128; $g=000; $b=000; break;
	case "red":	$r=255; $g=000; $b=000; break;
	case "purple":	$r=128; $g=000; $b=128; break;
	case "fuchsia":	$r=255; $g=000; $b=255; break;
	case "green":	$r=000; $g=128;	$b=000; break;
	case "lime":	$r=000; $g=255; $b=000; break;
	case "olive":	$r=128; $g=128; $b=000; break;
	case "yellow":	$r=255; $g=255; $b=000; break;
	case "navy":	$r=000;	$g=000;	$b=128;	break;
	case "blue":	$r=000; $g=000; $b=255; break;
	case "teal":	$r=000;	$g=128;	$b=128; break;
	case "aqua":	$r=000; $g=255; $b=255; break;
	default: 	$r=000; $g=000; $b=128; break; // IN THE NAVY!!

}

imagefilter($img, IMG_FILTER_COLORIZE, $r , $g, $b);

// printText($img,0,375,$r.",".$g.",".$b,$black,10);

$black = imagecolorallocate($img,0,0,0);

printText($img,8,8,$_POST['charactername'],$black,12);

if (isset($_FILES['avatar']) && $_FILES['avatar']['tmp_name'] != "" && exif_imagetype($_FILES['avatar']['tmp_name']) !== FALSE) {
	$av = imagecreatefromstring(file_get_contents($_FILES['avatar']['tmp_name']));
} else {
	$av = imagecreatefrompng("img/noavatar.png");
}

imagealphablending($av,true);
imagesavealpha($av, true);

imagecopyresampled($img,$av, 15, 25, 0, 0, 150, 150, imagesx($av),imagesy($av));

printText($img, 170, 40, "AKA:", $black);
printText($img, 220, 40, $_POST['username'],$black);
printText($img, 170, 55, "Level:",$black);
printText($img, 220, 55, $_POST['characterlevel'],$black);

printBio($img,170, 75, $_POST['bio'],$black);


$paX = 390;

printText($img, $paX, 40, "Personal Attributes",$black,12);

printText($img, $paX, 70, "Weapon Speed", $black);
printText($img, $paX + 160, 70, "50", $black);

printText($img, $paX, 85, "Health", $black);
printText($img, $paX + 160, 85, (200+$_POST['healthbonus']), $black);

printText($img, $paX, 100, "Max Adrenaline", $black);
printText($img, $paX + 160, 100, (200+$_POST['maxadrenaline']), $black);

printText($img, $paX, 115, "Damage Bonus", $black);
printText($img, $paX + 160, 115, (200+$_POST['damagebonus']), $black);

printText($img, $paX, 130, "Damage Reduction", $black);
printText($img, $paX + 160, 130, (200+$_POST['damagereduction']), $black);

printText($img, $paX, 145, "Max Ammo Bonus", $black);
printText($img, $paX + 160, 145, "".$_POST['maxammobonus'], $black);

$x = 30;
$y = 215;
$xplus = 300;
$levdist = 200;

printText($img, 250, 190, "Abilities",$black,12);

foreach ($abilities as $num => $ability) {
	$abily = str_replace("-","",str_replace(" ","",strtolower($ability)));
	if ($_POST[$abily."level"] > 0) {
		if ($xplus == 300) $xplus = 0;
		else $xplus = 300;
		
		printText($img, $x + $xplus, $y, $en_abilit[$num], $black);
		printText($img, $x + $xplus + $levdist, $y, "".($_POST[$abily.'prevlevel'] + 1), $black);
		
		if ($xplus == 300) $y += 20;
	}
}

imagecopyresampled($img,$border,0,0,0,0,600,400,600,400);

header("Content-type: image/png");
header('Content-Disposition: attachment; filename="card.png"');
imagepng($img);
imagedestroy($img);
imagedestroy($border);
?>